
class EnemyEntity : EntityProxy {
	
	color3 m_color;
	int m_hadTicks;
	bool m_arrived;
	vec2 m_currentDest;
	float m_arrivedTime;

	float init() 
	{
		m_color.r = rnd();
		m_color.g = rnd();
		m_color.b = rnd();
		//setColor(m_color);

		m_hadTicks = 0;
		
		setLabel("");
		
		//gotoRandomCorner();
		
		setSpacing(1);
		setSpeed( 100 );
		
		/*vec2 a;
		a.x = 1;
		a.y = 1;
		fireAt(a);*/
		
		//arrived();
		return 0.25;
	}

	float tick()
	{
		m_hadTicks++;
		
		updateLabel();
		updateAttack();
		
		/*if ( m_arrived ) {
			float ttw = 0.3 - (now() - m_arrivedTime);
			if ( ttw < 0 )
				gotoRandomLocation();
			else
				setLabel("ttw: "+ttw);
		}*/
		
		return 0.5;
	}
	
	float arrived()
	{
		/*if ( !m_arrived ) {
			m_arrived = true;
			m_arrivedTime = now();			
		}*/
		//setLabel("arrived:"+m_arrivedTime);
		
		//return 1;
		
		//if ( m_hadTicks < 20 /*|| m_hadTicks > 50*/ )
		//	return 1;
		
		//vec2 p = getPos();
		//print( "arrived at: "+p.x+","+p.y );
				
		/*vec2 d;
		if ( p.y < 36 ) {
			d.x = 8;
			d.y = 64;
			setSpeed(100);
		}
		else {
			d.x = 120;
			d.y = 8;
			setSpeed(100);
		}
		moveTo( d );
		m_arrived = false;*/
		//gotoRandomCorner();
		
		return 1;
	}
	
	float gainedRange(Entity@ e)
	{
		//print(getName()+" gained sight of:"+e.getName());
		//Entity@[] ve = getVisibleEnemies();
		//print( getName()+" now sees "+ve.length+" other entities" );
		updateAttack();
		return 0.25;
	}
	
	float lostRange(Entity@ e)
	{	
		//print(getName()+" lost sight of:"+e.getName());
		//Entity@[] ve = getVisibleEnemies();
		//print( getName()+" now sees "+ve.length+" other entities" );
		updateAttack();
		return 0.25;
	}
	
	float gainedSight(Entity@ e) { 
		updateAttack();
		return 0.25; 
	}
	
	float lostSight(Entity@ e) { 
		updateAttack();
		return 0.25;
	}
	
	void gotoRandomCorner() 
	{
		vec2 v;
		float r = rnd();
		if ( r < 0.25 ) {
			v.x = 128;
			v.y = 72;
		}
		else if ( r < 0.5 ) {
			v.x = 128;
			v.y = 0;
		}
		else if ( r < 0.75 ) {
			v.x = 0;
			v.y = 72;
		}
		else {
			v.x = 0;
			v.y = 0;
		}
		m_currentDest = v;
		float eta = moveTo( v );
		m_arrived = false;
		updateLabel();
	}
	
	void gotoRandomLocation()
	{
		vec2 v;
		v.x = rnd() * 128;
		v.y = rnd() * 72;
		m_currentDest = v;
		float eta = moveTo( v );
		m_arrived = false;
		updateLabel();
	}
	
	float userMoveTo(vec2 v)
	{
		//print( "userMoveTo:"+v.x+","+v.y );
		moveTo( v );
		m_currentDest = v;
		m_arrived = false;
		
		return 1;
	}
	
	float userMoveToQueue(vec2 v) 
	{
		moveToQueue( v );
		m_currentDest = v;
		m_arrived = false;
		
		return 1; 
	}

	void updateLabel() 
	{
		/*if ( ! m_arrived ) {
			setLabel( "eta: "+getETA(m_currentDest) );
			return;
		}
		else 
			setLabel("");*/
		
		vec2 p = getPos();
		vec2 v = getVel();
		string s = "";
		s += getName()+"\n";
		//s += "Ticks: "+m_hadTicks+"\n"+
		//s += "P: " + p.x + "," + p.y +"\n";
		//s += "V: " + v.x + "," + v.y +"\n";		
		s += "HP: " + getHitpoints()+"\n";
		s += "MV: " + getMaxVel()+"\n";
		//s += "VR: " + getVisibilityRange()+"\n";
		s += "AR: " + getAttackRange()+"\n";
		//s += "BS: " + getBulletSpeed()+"\n";
		s += "BR: " + getBlastRadius()+"\n";
		
		setLabel( s );
	}
	
	void updateAttack() 
	{
		Entity@[] ve = getVisibleEnemies();
		vec2 m = getPos();
		float bestDist = 1000;
		vec2 bestTarget;
		for ( uint i = 0; i < ve.length; i++ ) {
			vec2 p = ve[i].getPos();
			float dist = m.distanceTo(p);
			if ( dist > getBlastRadius() && dist < getAttackRange() && dist < bestDist ) {				
				bestDist = dist;
				bestTarget = p;
			}
		}
		if ( bestDist != 1000 )
			fireAt( bestTarget );
		else
			ceaseFire();
	}

}


